export declare class IDBContext {
    dbReady: Promise<IDBDatabase>;
    private txOptions;
    private tx;
    private txComplete;
    private request;
    private chain;
    constructor(idbDatabase: Promise<IDBDatabase> | IDBDatabase, txOptions?: {
        durability: string;
    });
    /**
     * Run a function with the provided object stores. The function
     * should be idempotent in case it is passed an expired transaction.
     */
    run<T>(mode: IDBTransactionMode, f: (arg: Record<string, Store>) => Promise<T> | T): Promise<T>;
    private performRun;
    sync(): Promise<void | undefined>;
    private setRequest;
}
declare class Store {
    private store;
    private addRequest;
    constructor(store: IDBObjectStore, addRequest: (request: IDBRequest) => Promise<any>);
    get(query: IDBValidKey | IDBKeyRange): Promise<any>;
    getAll(query: IDBValidKey | IDBKeyRange, count: number): Promise<any>;
    getKey(query: IDBValidKey | IDBKeyRange): Promise<any>;
    getAllKeys(query: IDBValidKey | IDBKeyRange, count: number): Promise<any>;
    put(value: unknown, key?: IDBValidKey): Promise<any>;
    delete(query: IDBValidKey | IDBKeyRange): Promise<any>;
    clear(): Promise<any>;
    index(name: string): Index;
}
declare class Index {
    private index;
    private addRequest;
    constructor(index: IDBIndex, addRequest: (request: IDBRequest) => Promise<any>);
    getAllKeys(query: IDBValidKey | IDBKeyRange, count?: number): Promise<any>;
}
export {};
